#!/bin/bash

BASE_DIR=`dirname "$0"`/..

arch_platform="unknown"
arch="`uname -m`"
platform="`uname -s`"
case "$arch-$platform" in
  i686-Linux)
    arch_platform="x86-linux"
    ;;
  x86_64-Linux)
    arch_platform="x86_64-linux"
    ;;
esac
if [ "$arch_platform" = "unknown" ] ; then
  echo "Failed to determine system type" 1>&2
  exit 1
fi

LIBS=`ldd "$BASE_DIR/lib/native/$arch_platform/libmathsatj.so" 2>&1 | grep "not found"`

if [ ! -z "$LIBS" ]; then
  echo "There are one or more necessary libraries missing on your system:"
  echo "$LIBS"
  echo "Please install them and run CPAchecker again."
  exit 1
fi
