/*
 *  CPAchecker is a tool for configurable software verification.
 *  This file is part of CPAchecker. 
 *
 *  Copyright (C) 2007-2008  Dirk Beyer and Erkan Keremoglu.
 *  All rights reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 *
 *  CPAchecker web page:
 *    http://www.cs.sfu.ca/~dbeyer/CPAchecker/
 */
package assumptions;

import org.eclipse.cdt.core.dom.ast.IASTExpression;

import symbpredabstraction.interfaces.SymbolicFormula;
import symbpredabstraction.interfaces.SymbolicFormulaManager;

/**
 * Extension of predicate abstraction's symbolic formula manager
 * with new makeAnd method that uses an expression rather
 * than CFA edge
 * 
 * @author g.theoduloz
 */
public interface AssumptionSymbolicFormulaManager extends SymbolicFormulaManager {
  
  /**
   * Creates a formula representing an AND of the two argument
   * @param f1 a SymbolicFormula
   * @param p an invariant predicate
   * @return The formula (f1 & e)
   */
  public SymbolicFormula makeAnd(SymbolicFormula f1, IASTExpression p);

}
