/*
 *  CPAchecker is a tool for configurable software verification.
 *  This file is part of CPAchecker. 
 *
 *  Copyright (C) 2007-2008  Dirk Beyer and Erkan Keremoglu.
 *  All rights reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 *
 *  CPAchecker web page:
 *    http://www.cs.sfu.ca/~dbeyer/CPAchecker/
 */
package cfa;

import java.util.ArrayList;

import cfa.objectmodel.CFANode;


public class CFATopologicalSort {

	ArrayList<Integer> visited;
	private int topSortId = 0;

	public CFATopologicalSort() {
		visited = new ArrayList<Integer>();
	}

	public void topologicalSort(CFANode node){

		visited.add(node.getNodeNumber());
		for(int i=0; i<node.getNumLeavingEdges(); i++){
			CFANode successor = node.getLeavingEdge(i).getSuccessor();
			if(!visited.contains(successor.getNodeNumber())){
				topologicalSort(successor);
			}
		}
		node.setTopologicalSortId(topSortId);
		topSortId++;
	}
}
