/*
 *  CPAchecker is a tool for configurable software verification.
 *  This file is part of CPAchecker. 
 *
 *  Copyright (C) 2007-2008  Dirk Beyer and Erkan Keremoglu.
 *  All rights reserved.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 *
 *  CPAchecker web page:
 *    http://www.cs.sfu.ca/~dbeyer/CPAchecker/
 */
package cfa.objectmodel.c;

import org.eclipse.cdt.core.dom.ast.IASTDeclSpecifier;
import org.eclipse.cdt.core.dom.ast.IASTDeclarator;

import cfa.objectmodel.CFANode;
import cfa.objectmodel.c.DeclarationEdge;


/**
 * An edge to store declarations for global variables. These are different
 * from standard declarations, in that they can have also an initializer
 * for the declared variable
 *
 * @author Alberto Griggio <alberto.griggio@disi.unitn.it>
 */
public class GlobalDeclarationEdge extends DeclarationEdge {

    public GlobalDeclarationEdge(String rawStatement, CFANode predecessor, CFANode successor,
            IASTDeclarator[] declarators, IASTDeclSpecifier specifier) {
        super(rawStatement, predecessor, successor, declarators, specifier);
    }

}
